**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

# Howto APU

## minicom

~~~
pu port             /dev/ttyUSB0
pu baudrate         38400
pu rtscts           No 
pu xonxoff          Yes
~~~

~~~
pu port             /dev/ttyUSB0
pu baudrate         115200
pu rtscts           No 
pu xonxoff          Yes
~~~

On peut aussi lancer la commande directement : `$ minicom -b 115200 -D /dev/ttyUSB0`

## Installation flashrd

Suivre <http://arnaud.tomei.fr/alix-openbsd#installation-du-systeme>

## Adaptations de base

~~~
rw
passwd
echo 'PKG_PATH="ftp://ftp.openbsd.org/pub/OpenBSD/5.7/packages/amd64/"\nexport PKG_PATH' >> /root/.profile
echo routeur > /etc/myname
echo 'net.inet.ip.forwarding=1\nnet.inet.ip.redirect=0\nnet.inet6.ip6.forwarding=1\nnet.inet6.ip6.accept_rtadv=0' >> /etc/sysctl.conf
echo 'description "LAN"\ninet 192.168.12.1 255.255.255.0 NONE' > /etc/hostname.re2
sync
~~~

## Persistance de /var et /home

Dans /etc/rc.flashrd.sub vérifier que les lignes suivantes sont présentes et décommentées :

~~~
tardirs="var"
set -A tarsize 64M                      # tmpfs sizes for tar dirs
#
# If you want to save all "tardirs" contents on shutdown:
savetardirs="$tardirs"
~~~

Le ramdisk de /var sera ainsi sauvegardé dans /flash/var.tar à l'extinction du routeur, et décompacté au démarrage.

Si des modifications importantes sont faites, il est possible de régénérer l'archive manuellement ainsi :

~~~
tar cf /flash/var.tar -C /var .
~~~

Pour /home :

~~~
mkdir /flash/home/
rmdir /home
cat /etc/rc.local                                                            
#       $OpenBSD: rc.local,v 1.44 2011/04/22 06:08:14 ajacoutot Exp $

# Site-specific startup actions, daemons, and other things which
# can be done AFTER your system goes into securemode.  For actions
# which should be done BEFORE your system has gone into securemode
# please see /etc/rc.securelevel.

rmdir /home
ln -sf /flash/home /home
# Run flashrd final boot routine
/etc/rc.flashrd.local
~~~

Ainsi, /home devient un lien symbolique vers le répertoire /flash/home qui est sur une partition persistante. C'est la méthode à préférer quand /home ne contient que des données "froides".

Il est également possible dans le cas ou /home accueillerait des données écrites fréquemment de créer un ramdisk à la manière de /var. Dans ce cas, au lieu de réaliser la procédure précédente, il faut modifier le fichier /etc/rc.flashrd.sub comme ceci :

~~~
tardirs="var home"
set -A tarsize 64M 32M                     # tmpfs sizes for tar dirs
#
# If you want to save all "tardirs" contents on shutdown:
savetardirs="$tardirs"
~~~

Et de la même manière, pour sauvegarder l'arborescence sans attendre le prochain reboot (propre ! Sinon les données depuis la dernière archive sont perdues) :

~~~
tar cf /flash/home.tar -C /home .
~~~