**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**


## Failover DHCP master/master

Ce mode permet à deux serveurs DHCP de fonctionner simultanément sur un même LAN.

Les leases dynamiques sont alors partagés entre les 2 serveurs et synchronisés via un échange réseau entre les serveurs. En cas de panne de l'un deux, l'autre prend alors à sa charge l'ensemble des leases.

Pour cela, il est nécessaire d'ajouter une section "failover" sur chacun des serveurs. Exemple :

Master :

~~~
failover peer "dhcp-failover" {
        primary;
        address 192.0.2.1;
        peer address 192.0.2.2;
        port 647;
        peer port 647;
        max-response-delay 30;
        max-unacked-updates 10;
        load balance max seconds 3;
        split 128;
        mclt 1800;
}
~~~

Slave :

~~~
failover peer "dhcp-failover" {
        secondary;
        address 192.0.2.2;
        peer address 192.0.2.1;
        port 647;
        peer port 647;
        max-response-delay 30;
        max-unacked-updates 10;
        load balance max seconds 3;
}
~~~

Il est également nécessaire d'englober la directive "range" et les sections "host" dans une section "pool", et l'on déclarera celle-ci en mode failover. Exemple :

~~~
subnet 192.0.2.0 netmask 255.255.0.0 {
  option routers 192.2.0.254;

  pool {
    failover peer "dhcp-failover";
    range 192.0.2.100 192.0.2.200;

    host host1 {
          hardware ethernet 08:00:1f:82:7a:72;
          fixed-address 192.0.2.4
    }

    [...]
}
~~~

## Divers

### Redémarrage sous OpenBSD

Un SIGHUP ne semble pas fonctionner pour appliquer les changements de la configuration.

Il est donc conseillé de l'arrêter et de le relancer.

~~~
ps aux | grep dhcpd
kill -15 PID_DU_PROCESSUS
~~~

Puis relancer le processus comme il était lancé, exemple : 

~~~
/usr/sbin/dhcpd bnx0
~~~
