**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

# Howto Initramfs debug

Inspiré de [<https://wiki.debian.org/InitramfsDebug>] et [<https://wiki.debian.org/CryptsetupDebug>]

On a pu constater lors de mise à jour noyau des soucis lors de la regération de l'initramfs sur des portables Debian Jessie avec des partitions chiffrées

## En cas de soucis au démarrage du type

~~~
Reading all physical volumes. This may take a while ...
No volume groups found
~~~

On obtient souvent avant l'invit initramfs et busybox une note du type

~~~
Alert ! /dev/disk/by-uuid/dc0e0033-1e4c-41f9-8ebb-e3d3f8e03459 does not exist. Dropping to a shell!
~~~

C'est souvent lié à un changement mal géré de UUID sur l'une des partitions (notamment chiffré voire plus rarement un cas de mauvaise gestion d'ajout de partition en LVM [non traité ici] )

Il faut avoir en tête que la syntaxe de /etc/crypttab (fichier listant les partitions qui seront déchiffrés au démarrage [[<http://trac.evolix.net/infogerance/wiki/HowtoChiffrementData>]])
peut être soit :

~~~
sda7_crypt   UUID=459a6a8b-0e49-4ba2-b436-6b97400bf761 none luks
~~~

ou

~~~
sda7_crypt      /dev/sda7       none    luks
~~~

Le conseil est donc à l'aide de [<http://trac.evolix.net/infogerance/wiki/HowtoLiveCD>] de se chroot sur le système (sans oublier d'efi) et de modifier le /etc/crypttab (voire /etc/fstab) avec des /dev/sdaX plutôt que les UUID (à moins de les valider/verifier avec _ls -l /dev/disk/by-uuid_ ou _blkid_)

L'autre conseil est de ne pas utiliser l'utilitaire update-initramfs pour regénérer les initrd.img du type

~~~
update-initramfs -k -all -u
~~~

## Préférer la méthode suivante
(en ayant fait un backup de votre /boot/initrd.img-${uname -r} (ex : /boot/initrd.img-3.16.0-4-amd64 )) :

~~~
cd /boot/initramfs
find . | cpio -H newc --create --verbose | gzip -9 > ../initrd.img-${uname -r}
~~~

Puis réinstallez grub
