**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

# Howto Mailman

~~~
# apt install mailman nginx fcgiwrap postfix
~~~

Configuration basique via le fichier /etc/mailman/mm_cfg.py

~~~
DEFAULT_URL_PATTERN = '<http://%s/'>
DEFAULT_SERVER_LANGUAGE = 'fr'
~~~

Il faut obligatoirement définir une liste nommée "mailman" avec listmaster / mot de passe :

~~~
# /usr/lib/mailman/bin/newlist mailman
~~~

On créera également un mot de passe global (a priori pour autoriser la création de listes) :

~~~
# mmsitepass
~~~

## Configuration avec Nginx

~~~
server {

    listen 80;
    server_name lists.example.com
    root /usr/lib/cgi-bin/mailman;

    location = / {
     rewrite ^ /listinfo permanent;
    }

    location / {
      fastcgi_split_path_info ^(/[^/]*)(.*)$;
      fastcgi_pass unix:/var/run/fcgiwrap.socket;
      include fastcgi.conf;
      fastcgi_param PATH_INFO         $fastcgi_path_info;
      fastcgi_param PATH_TRANSLATED   $document_root$fastcgi_path_info;
    }

    location /mailman-icons {
      alias /usr/lib/mailman/icons;
    }

    location /archives {
      alias /var/lib/mailman/archives/public;
      autoindex on;
    }

}
~~~

## Configuration avec Postfix 

main.cf :

~~~
alias_maps = hash:/etc/aliases hash:/var/lib/mailman/data/aliases
alias_database = hash:/etc/aliases hash:/var/lib/mailman/data/aliases
mydestination = lists.example.com
transport_maps = hash:/etc/postfix/transport
mailman_destination_recipient_limit = 1
~~~

transport :

~~~
lists.example.com mailman:
~~~

mm_cfg.py :

~~~
MTA='Postfix'
~~~

~~~
# /usr/lib/mailman/bin/genaliases
# /etc/init.d/mailman restart
# /etc/init.d/postfix restart
~~~
