---
categories: hardware
title: Howto Master switch APC
...

* Documentation : <http://www.apc.com/fr/fr/prod_docs/results.cfm?DocType=User%20Manual>

## Installation

Cette partie est normalement documentée dans la section **Remote access to the control console** du manuel.

En résumé :

- Relever l'adresse MAC de l'APC
- Depuis une autre machine : arp -s <future_IP_APC> <MAC_APC> (Note : cela doit apparemment être fait sur une machine avec future_IP_APC comprise dans le réseau d'une *vraie* interface (par exemple, cela ne semble pas marcher avec eth0:0... même en faisant arp -i eth0:0 -s <future_IP_APC> <MAC_APC>)
- Depuis cette autre machine, faire un : ping -s 113 <future_IP_APC>
- Puis : telnet <future_IP_APC> avec le login/passwd apc/apc.
- En fin, bien penser à lui fixer son adresse IP définitive !!

## Manipulations de base

- Définir le nom et domaine de l'APC (dans 2>1>5>1 et 3>2>1)
- Positionner les paramètres réseaux (IP/Netmask/Gateway), DNS
- Configurer un serveur NTP, et se mettre en timezone GMT
- Changer le login/passwd
- Relever les machines branchées à ses ports

## Commande pour CLI du modèle AP8959EU3

### Commandes générales :

~~~
system -n APC42 # changer le nom de l'APC
reboot # redémarrer le firmware (ne redémarre pas les outlets ;-)
console -S telnet # active le telnet ET désactive le SSH
snmp -S enable # active le SNMP
userPasswd root 
user -an root -ap PASSWORD # change le mot de passe du compte admin "root"
system # liste des infos de l'APC
prodInfo # liste des infos de l'APC
~~~

### Gestion du réseau :

~~~
apc> help tcpip
Usage: tcpip  -- Configure and display TCP/IP v4 parameters
    tcpip [-S <enable | disable>]
          [-i <ipv4 address>]
          [-s <subnet mask>]
          [-g <gateway>]
          [-d <domain name>]
          [-h <host name>]
~~~

**tcpip -h** est le hostname "réseau", il est différent du hostname "système" (**system -n**)

### Contrôle des ports :

~~~
olName all # liste tous les ports
olStatus all # liste tous les ports avec le status des ports
olStatus 3 # liste le status du port 3
olName 3 salut # renomme le port 3 en "salut"
olReboot 3 # reboot le port 3 (salut donc)
olOff 3 # éteint le port salut
olOn 3 # allume le port salut
appcli # passe en mode CLI spécial pour gérer les outlets
~~~

## Mise à jour du firmware

**Voir si l'on possède les anciens binaires... certains binaires récents semblent incompatibles avec du vieux matériel**

* Télécharger les binaires (un binaire pour AOS et un binaire pour le rpdu?)
* Se connecter en FTP avec le login administrateur
* passer en mode binaire (binary) et uploader le firmware "aos"
* une fois terminée, l'APC redémarre tout seul
* une fois redémarré, se connecter à nouveau en FTP, passer en mode binaire et uploader le firmware "Rack PDU APP" ('rpdu?)
* Cela redémarre, l'upgrade est terminée


## Port série

Exemple pour screen :

~~~
screen /dev/ttyUSB3 9600
~~~

Exemple pour cu :

~~~
cu -l /dev/cuaU0 -s 9600
~~~

Attention, parfois les caractères sont illisibles (problème matériel ?)
et il faut taper les commandes à l'aveugle...

## Reset des accès

Il faut, a priori, appuyer 2 fois sur RESET et brancher un port série, on pourra ainsi accéder
via le port série avec le login **apc** et le mot de passe **apc**