---
categories: network
title: Howto Nmap
---


* Documentation Nmap : <https://nmap.org/docs.html>


[Nmap](https://nmap.org/) est un outil libre très populaire de scan de ports & de réseaux. Il est couplé d'un puissant moteur d'exécution de scripts qui permet notamment, suite à un scan, d'identifier la machine et les services détectés.


## Installation

~~~
# apt install nmap

$ nmap -V

Nmap version 7.40 ( https://nmap.org )
Platform: x86_64-pc-linux-gnu
Compiled with: liblua-5.3.3 openssl-1.1.0c libpcre-8.39 libpcap-1.8.1 nmap-libdnet-1.12 ipv6
Compiled without:
Available nsock engines: epoll poll select
~~~

## Exemples d'utilisation

### Détecter rapidement les machines présentes sur un réseau

Pour lister/trouver les machines actives sur un réseau, on peut faire un scan par ping :
~~~
$ nmap -sP 192.0.2.0/24
$ nmap -6 -sP 2001:0DB8::/32
~~~

### Générer un rapport

Nmap est distribué une feuille de style xsl utilisable sur la sortie xml. Dans le paquetage Debian de Nmap, la feuille de style se trouve dans `/usr/share/nmap/nmap.xsl`. Par défaut, elle ne semble pas bien prise en compte, mais on peut notamment l'héberger nous même ou utiliser celle en ligne sur nmap.org et spécifier l'url avec l'option --stylesheet

~~~
# nmap -sS -oX /var/www/scans/.xml --stylesheet https://nmap.example.org/nmap.xsl 192.0.2.42
~~~
