**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été totalement révisée.**

# Howto Prestashop

## Prérequis

* Serveur Apache ou Nginx
* PHP 5.4 ou plus.
* Extensions PHP indispensables : PDO_MySQL, cURL, SimpleXML, mcrypt, GD, OpenSSL, DOM, SOAP, Zip, fileinfo.
* MySQL 5.0 ou plus.


Réglages php.ini:

~~~
allow_url_fopen on
register_globals Off
memory_limit >= 128M
upload_max_filesize >= "16M"
~~~

Réglages Apache : 

* mod_rewrite actif
* mod_security désactivé
* mod_auth_basic désactivé.
* AllowOverride AuthConfig Limit FileInfo Indexes Options 


Bonus : 

* Possibilité d'avoir des cron
* Memache

Plus de détail sur la [documentation de Prestashop](http://doc.prestashop.com/display/PS17/What+you+need+to+get+started)

## Installation

Télécharger la dernière version _stable_ de prestashop par archive ou par dépôt git.

Selon la version, peut avoir un problème dans le fichier `config/autoload.php` : commenter la ligne qui gène si optionnel.

* Utiliser la ligne de commande pour installer prestashop:

~~~
php './install-dev/index_cli.php' --language=fr --timezone='localhost' --base_uri='/' --domain='{{ host }}' \
--db_server='{{ db_host }}' --db_user='{{ db_user }}' --db_password='{{ db_pwd }}' --db_name='{{ db_name }}' \
--db_clear=0 --db_create=0 --name='{{ site_title }}' --firstname='{{ firstname }}' --lastname='{{ lastname }}' \
--password='{{ admin_pwd }}' --email='{{ admin_email }}' --newsletter=0
~~~

* supprimer le repertoire `install-dev`
* S'assurer des droits pour le groupe <user> afin que l'instance du serveur web lancé en tant que www-<user> puisse écrire dans les répertoires.

~~~
$ chmod -R g+w config/ cache/ log/ img/ mails/ modules/ themes/ translations/ upload/ download/
~~~

* Après installation :

~~~
$ mv admin/ admin$RANDOM/
~~~

## Optimisation

Utiliser [Memcached](HowtoMemcached)

## Modules

### Soucis connu avec gamification

Le module gamification fait appel à une ip externe, qui, si ne répond pas, empêche une connexion à l'interface admin (la connexion sera très lente, voir impossible).
Le mieux est de désactiver le module (temporairement du moins) en renommant le répertoire du module:

~~~{.bash}
$ mv ~/www/modules/gamification{,.old}
~~~