---
title: Howto Weechat
categories: tips
...

* <https://weechat.org/>
* <https://weechat.org/files/doc/stable/weechat_user.fr.html>


**Weechat** 

## Installation

Sur Debian :

~~~{.bash}
apt install weechat
~~~

Sur OpenBSD :

~~~{.bash}
pkg_add weechat
~~~

## Configuration rapide

Lancer weechat :

~~~{.bash}
$ weechat
~~~

Changer son nick, username, realname

~~~
/set irc.server_default.nicks "foo"
/set irc.server_default.username "foo"
/set irc.server_default.realname "foo bar"
~~~

*Configurer ses highlights*

Mots à «highlighter»

~~~
/set weechat.look.highlight foo,bar
~~~

Faire des highlights un peu plus sophistiqués (ie: à base de regex)

~~~
/set weechat.look.highlight_regex ^\*|^\* :|^\*:
~~~

Pour les désactiver

~~~
/set weechat.look.highlight_regex ""
~~~

Couleur des highlights dans les channels

~~~
/set weechat.color.chat_highlight yellow
/set weechat.color.chat_highlight_bg red
~~~

Couleur des highlights dans la bar de status

~~~
/set weechat.color.status_data_highlight red
/set weechat.color.status_data_private red
~~~

Être highlighté à chaque message dans le canal courrant

~~~
/buffer set highlight_regex .*
~~~

*Ajouter des servers/channels avec connexion automatique*

Ajouter des servers avec connexion automatique

~~~
/server add freenode chat.freenode.net/6697 -ssl -autoconnect
~~~

Ajouter des channels avec connexion automatique

~~~
/set irc.server.freenode.autojoin "#debian,#openbsd,#evolix"
~~~


*Organiser ses buffers*

Inverser les buffers 3 et 4

~~~
/buffer swap 4 3
~~~

Déplacer un buffer

~~~
/buffer move 3
~~~

Merger des buffers

ex : dans un des buffers qu'on veut merger

~~~
/buffer merge <n° du buffer que l'on veut ajouter>
~~~

Sauvegarder

~~~
/save
~~~

Sauvegarder son layout

~~~
/layout store
/save
~~~

Sortir d'un buffer

~~~
/part
~~~

Fermer un buffer

~~~
/close
~~~
